HDU/HDOJ 1015(dfs或暴力枚举)

来源:互联网 发布:淘宝刷销量怎么刷 编辑:程序博客网 时间:2024/05/17 22:27

Safecracker

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 13441    Accepted Submission(s): 7016


Problem Description
=== Op tech briefing, 2002/11/02 06:42 CST === 
"The item is locked in a Klein safe behind a painting in the second-floor library. Klein safes are extremely rare; most of them, along with Klein and his factory, were destroyed in World War II. Fortunately old Brumbaugh from research knew Klein's secrets and wrote them down before he died. A Klein safe has two distinguishing features: a combination lock that uses letters instead of numbers, and an engraved quotation on the door. A Klein quotation always contains between five and twelve distinct uppercase letters, usually at the beginning of sentences, and mentions one or more numbers. Five of the uppercase letters form the combination that opens the safe. By combining the digits from all the numbers in the appropriate way you get a numeric target. (The details of constructing the target number are classified.) To find the combination you must select five letters v, w, x, y, and z that satisfy the following equation, where each letter is replaced by its ordinal position in the alphabet (A=1, B=2, ..., Z=26). The combination is then vwxyz. If there is more than one solution then the combination is the one that is lexicographically greatest, i.e., the one that would appear last in a dictionary." 

v - w^2 + x^3 - y^4 + z^5 = target 

"For example, given target 1 and letter set ABCDEFGHIJKL, one possible solution is FIECB, since 6 - 9^2 + 5^3 - 3^4 + 2^5 = 1. There are actually several solutions in this case, and the combination turns out to be LKEBA. Klein thought it was safe to encode the combination within the engraving, because it could take months of effort to try all the possibilities even if you knew the secret. But of course computers didn't exist then." 

=== Op tech directive, computer division, 2002/11/02 12:30 CST === 

"Develop a program to find Klein combinations in preparation for field deployment. Use standard test methodology as per departmental regulations. Input consists of one or more lines containing a positive integer target less than twelve million, a space, then at least five and at most twelve distinct uppercase letters. The last line will contain a target of zero and the letters END; this signals the end of the input. For each line output the Klein combination, break ties with lexicographic order, or 'no solution' if there is no correct combination. Use the exact format shown below."
 

Sample Input
1 ABCDEFGHIJKL11700519 ZAYEXIWOVU3072997 SOUGHT1234567 THEQUICKFROG0 END
 

Sample Output
LKEBAYOXUZGHOSTno solution
 

Source
Mid-Central USA 2002
 

Recommend
此题大意:给你一个目标值和一个长度在5~12的字符串,叫你从该字符串中找到五个字符,其对应的值(A-1,B-2.....)满足“v - w^2 + x^3 - y^4 + z^5 = target ”,然后就输出所有满足条件中字典序最大的,如果没有满足条件的字符串,则输出“no solution”。
此题数据量较小,所以可以暴力枚举(5层for循环加判断),找到最大字典序并满足要求的字符串后就停止循环。


#include <bits/stdc++.h>using namespace std;bool comp(const char& a,const char& b){return a>b;}int main(){int aim,i,j,k,p,q;int a,b,c,d,e;char str[55];while(cin>>aim>>str){if(aim == 0 && !strcmp(str,"END")){break;}int len = strlen(str);bool flag = 0;sort(str,str+len,comp);for(i=0 ;i<len ;i++){for(j=0 ;j<len ;j++){if(j==i)continue;for(k=0 ;k<len ;k++){if(k==j || k==i)continue;for(p=0 ;p<len ;p++){if(p==i || p==j ||p==k)continue;for(q=0 ;q<len ;q++){if(q==i || q==j || q==k || q==p)continue;a = str[i] - 'A' + 1;b = str[j] - 'A' + 1;c = str[k] - 'A' + 1;d = str[p] - 'A' + 1;e = str[q] - 'A' + 1;if(a-b*b+c*c*c-d*d*d*d+e*e*e*e*e == aim){printf("%c%c%c%c%c\n",str[i],str[j],str[k],str[p],str[q]);flag = 1;}if(flag)break;}if(flag)break;}if(flag)break;}if(flag)break;}if(flag)break;}if(!flag){printf("no solution\n");}}return 0;}

思路二:dfs,模板题,水~:
#include <bits/stdc++.h>using namespace std;char str[55],ans[10];int aim,vis[15],len;bool flag;bool comp(const char& a,const char& b){return a>b;}bool check(char* s){int i,a,b,c,d,e;a = s[0] - 'A' + 1;b = s[1] - 'A' + 1;c = s[2] - 'A' + 1;d = s[3] - 'A' + 1;e = s[4] - 'A' + 1;if(a - b*b + c*c*c - d*d*d*d + e*e*e*e*e == aim)return true;return false;}void dfs(int deepth){if(deepth == 5){if(check(ans))flag = 1;return;}int i;for(i=0 ;i<len ;i++){if(!vis[i]){vis[i] = 1;ans[deepth] = str[i];dfs(deepth+1);if(flag)return;vis[i] = 0;}}}int main(){while(cin>>aim>>str){if(aim==0 && !strcmp(str,"END"))break;flag = 0;len = strlen(str);memset(vis,0,sizeof(vis));sort(str,str+len,comp);dfs(0);if(flag){ans[5] = '\0';puts(ans);}else{cout << "no solution" << endl;}}return 0;}



0 0